#pragma GCC optimize("O3")

#include <bits/stdc++.h>

using namespace std;

#define ll long long
#define lf long double
#define all(vec) vec.begin(), vec.end()
#define rall(vec) vec.rbegin(), vec.rend()
#define nl "\n"
#define chmyax(a, b) a = max(a, b)
#define chmyin(a, b) a = min(a, b)

int main() {
  ios_base::sync_with_stdio(0);
  cin.tie(0);
  cout.tie(0);
  // freopen("in", "r", stdin);
  ll a, b, c, d, e, f, g, n, m, k;
  char ch;
  cin >> n >> m;
  vector<vector<bool>> arr(n + 2, vector<bool>(m + 2, 0));
  for (ll i = 1; i <= n; i++) {
    for (ll j = 1; j <= m; j++) {
      cin >> ch;
      arr[i][j] = ch == '#';
    }
  }
  vector<vector<bool>> rotatable(n + 2, vector<bool>(m + 2, 0));
  for (ll i = 1; i <= n; i++) {
    for (ll j = 1; j <= m; j++) {
      if (arr[i][j] && (!arr[i + 1][j] || !arr[i - 1][j])) {
        rotatable[i][j] = 1;
      }
    }
  }
  ll cnt = 0;
  for (ll i = 1; i <= n; i++) {
    for (ll j = 1; j <= m; j++) {
      if (!arr[i][j])
        continue;
      if (rotatable[i][j] && !rotatable[i][j - 1] && !rotatable[i][j + 1])
        rotatable[i][j] = 0;
      if (rotatable[i][j]) {
        if (!rotatable[i][j - 1] || !arr[i][j - 1])
          cnt++;
      } else {
        if (rotatable[i - 1][j] || !arr[i - 1][j])
          cnt++;
      }
    }
  }
  /*for (ll i = 0; i < n + 2; i++) {
    for (ll j = 0; j < m + 2; j++) {
      cout << arr[i][j];
    }
    cout << nl;
  }
  cout << nl;
  for (ll i = 0; i < n + 2; i++) {
    for (ll j = 0; j < m + 2; j++) {
      cout << rotatable[i][j];
    }
    cout << nl;
  }
  cout << nl;*/
  cout << cnt;
}
