#include <iostream>
#include <vector>

using namespace std;
using ll = long long;

int main() {
	ll N, M, ans = 0;
	bool changes = true;
	cin >> N >> M;
	vector<vector<char>> a(N + 2, vector<char>(M + 2, '.'));
	for (ll i = 1; i <= N; i++) {
		for (ll j = 1; j <= M; j++) {
			cin >> a[i][j];
			if (a[i][j] == '#') {
				a[i][j] = '-';
			}
		}
	}
	while (changes) {
		changes = false;
		for (ll i = 1; i <= N; i++) {
			for (ll j = 1; j <= M; j++) {
				if (a[i][j] == '-') {
					if ((a[i][j + 1] != '-' || a[i][j - 1] != '-') && (a[i - 1][j] == '|' || a[i + 1][j] != '.')) {
						a[i][j] = '|';
						changes = true;
					}
				}
			}
		}
	}
	changes = true;
	while (changes) {
		changes = false;
		for (ll i = 1; i <= N; i++) {
			for (ll j = 1; j <= M; j++) {
				if (a[i][j] == '|') {
					if ((a[i - 1][j] != '|' && a[i + 1][j] != '|') || (a[i][j + 1] == '-' && a[i][j - 1] == '-' && (a[i + 1][j] != '|' || a[i - 1][j] != '|'))) {
						a[i][j] = '-';
						changes = true;
					}
				}
			}
		}
	}
	for (ll i = 0; i <= N; i++) {
		for (ll j = 0; j <= M; j++) {
			if (a[i][j] != '-') {
				if (a[i][j + 1] == '-') {
					ans++;
				}
			}
			if (a[i][j] != '|') {
				if (a[i + 1][j] == '|') {
					ans++;
				}
			}
		}
	}
	cout << ans << '\n';
}