def clear_rect(i, j):
    global lst
    queue = [i, j]
    while len(queue) > 0:
        i, j = queue.pop(0), queue.pop(0)
        lst[i][j] = '.'
        if i > 0 and lst[i-1][j] == '*':
            queue += [i-1, j]
        if i < n-1 and lst[i+1][j] == '*':
            queue += [i+1, j]
        if j > 0 and lst[i][j-1] == '*':
            queue += [i, j-1]
        if j < m-1 and lst[i][j+1] == '*':
            queue += [i, j+1]

n, m = [int(i) for i in input().split()]
lst = [list(input()) for i in range(n)]
count = 0

for i in range(n):
    for j in range(m):
        if lst[i][j] == '*':
            count += 1
            clear_rect(i, j)

print(count)