#include <bits/stdc++.h>
using namespace std;

long long arr[200005] = {0};
long long arr1[200005] = {0};

long long DP_call(int n, int pos, int call) {
    long long result = 0;
    if(call < 0) return ((long long)1e-16 / 2);
    else {
        if(call >= 1) result = arr1[call - 1];
        long long mini = (long long)1e16 / 2, maxi = (long long)-1e16 / 2;
        for(int i = call; i <= pos; ++i) {
            mini = min(arr[i], mini);
            maxi = max(arr[i], maxi);
        }
        result += maxi - mini;
    }
    return result;
}

long long DP(int n) {
    for(int i = 0; i < n; ++i) {
        arr1[i] = 0;
    }
    long long maxi = (long long)-1e16 / 2;
    for(int i = 1; i < n; ++i) {
        for(int j = i; abs(i - j) <= 25 and j >= 0; --j) {
            maxi = max(DP_call(n, i, j), maxi);
        }
        arr1[i] = maxi;
    }
    return arr1[n - 1];
}

long long cut_res(long long n) {
    long long res = 0;
    long long j = 0;
    bool rising = 0, flag = 1;
    for(long long i = 0; i < n; ++i) {
        flag = 1;
        if(i - j == 1) {
            if(arr[i] > arr[j]) rising = 1;
            else rising = 0;
        }
        if(i - j >= 1) {
            if(rising == arr[i + 1] < arr[i] and i < n - 2) {
                res += abs(arr[i] - arr[j]);
                cout << i << " " << j << " res=" << res << "\n";
                j = i + 1;
            }
        }
        if(i == n - 1) {
            res += max(abs(arr[i] - arr[j]), abs(arr[i - 1] - arr[j]));
            cout << i << " " << j << " res=" << res << "\n";
        }
    }
    return res;
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    long long n, q, l, r, x;
    cin>>n >> q;
    for(long long i = 0; i < n; ++i) {
        cin >> arr[i];
    }

    for(int i = 0; i < q; ++i) {
        cin >> l >> r >> x;
        --l; --r;
        for(int j = l; j <= r; ++j) {
            arr[j] += x;
        }
        cout << DP(n) << "\n";
    }

    return 0;
}
