#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <algorithm>
#include <vector>
#include <math.h>
#include <random>
#include <iomanip>
#include <stack>
#include <set>
#include <map>
#include <queue>
#include <numeric>

using namespace std;

#define LF '\n';
typedef long long lli;
typedef long double ld;

const lli N = 1200;
const lli M = 11;
const lli INF = 1e9;

lli dp[N][M][N];
lli arr[N][M];

void sigmin(lli& a, lli b) {
    a = min(a, b);
}

void solve()
{
    lli n, m;
    cin >> n >> m;
    for (int i = 1; i <= n; i++) {
        for (int j = 1; j <= m; j++) {
            char c;
            cin >> c;
            if (c == '#')arr[i][j] = 1;
        }
    }
    for (int i = 0; i < N; i++)for (int j = 0; j < M; j++)for (int k = 0; k < N; k++)dp[i][j][k] = INF;
    if (arr[1][1]) {
        dp[1][1][0] = 1;
        dp[1][1][1] = 1;
    }
    else {
        dp[1][1][0] = 0;
        dp[1][1][1] = 0;
    }
    for (int i = 1; i <= n; i++) {
        for (int j = 1; j <= m; j++) {
            for (int mask = 0; mask < (1 << m); mask++) {
                lli ti = i;
                lli tj = j + 1;
                if (tj > m) {
                    tj = 1;
                    ti = i + 1;
                }
                if (arr[ti][tj] == 0) {
                    dp[ti][tj][mask] = min(dp[ti][tj][mask],dp[i][j][mask]);
                    continue;
                }
                lli curr_mask = mask;
                if (curr_mask & (1 << tj))curr_mask ^= (1 << tj);
                lli z = dp[i][j][mask] + 1;
                if (arr[ti-1][tj] && !(mask & (1 << tj)))z--;
                sigmin(dp[ti][tj][curr_mask],z);

                curr_mask ^= (1 << tj);
                z = dp[i][j][mask] + 1;
                if (tj != 1 && arr[ti][tj - 1] && mask & (1 << (tj - 1)))z--;
                sigmin(dp[ti][tj][curr_mask],z);
            }
        }
    }
    lli ans = 1e9;
    for (int i = 0; i < (1 << m); i++)ans = min(ans, dp[n][m][i]);
    cout << ans;
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
#ifdef _DEBUG
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif 

    solve();
}

