#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <algorithm>
#include <vector>
#include <math.h>
#include <random>
#include <iomanip>
#include <stack>
#include <set>
#include <map>
#include <queue>
#include <numeric>

using namespace std;

#define LF '\n';
typedef long long lli;
typedef long double ld;

vector<lli> v;

const lli INF = 1e18 + 2;

lli func(lli n) {
    vector<lli> dp;
    dp.resize(n + 1);
    for (int i = 1; i <= n; i++) {
        lli minn = INF, maxx = -INF;
        for (int j = i; j >= max(1,j-1000); j--) {
            minn = min(minn, v[j]);
            maxx = max(maxx, v[j]);
            dp[i] = max(dp[i],dp[j - 1] + maxx - minn);
        }
    }
    return dp[n];
}

void solve()
{
    lli n, q;
    cin >> n >> q;
    v.resize(n + 1);
    for (int i = 1; i <= n; i++)cin >> v[i];
    for (int i = 1; i <= q; i++) {
        lli l, r, x;
        cin >> l >> r >> x;
        for (int j = l; j <= r; j++)v[j] += x;
        lli ans = func(n);
        cout << ans << LF;
    }

}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
#ifdef _DEBUG
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif 


    solve();
}