#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;
int main(){
    ios::sync_with_stdio(0);
    cin.tie(0);
    ll n, m;
    cin >> n >> m;
    bool visited[n][m];
    bool table[n][m];
    vector<pair<ll, ll>> values;
    for(ll i = 0; i<n; i++){
        for(ll j = 0; j<m; j++){
            char temp;
            cin >> temp;
            visited[i][j]=false;
            if(temp=='*'){
                table[i][j]=true;
                values.push_back({i, j});
            }
            else table[i][j]=false;
        }
    }
    ll answer = 0;
    for(auto element : values){
        if(!visited[element.first][element.second]){
            answer++;
            queue<pair<ll, ll>> q;
            q.push({element.first, element.second});
            while(!q.empty()){
                pair<ll, ll> now = q.front();
                q.pop();
                if(visited[now.first][now.second]) continue;
                visited[now.first][now.second]=true;
                if(now.first!=0 && table[now.first-1][now.second]) q.push({now.first-1, now.second});
                if(now.first!=n-1 && table[now.first+1][now.second]) q.push({now.first+1, now.second});
                if(now.second!=0 && table[now.first][now.second-1]) q.push({now.first, now.second-1});
                if(now.second!=m-1 && table[now.first][now.second]) q.push({now.first, now.second+1});
            }
        }
    }
    cout << answer;
}