#pragma GCC optimize("O3")

#include <bits/stdc++.h>

using namespace std;

#define ll long long
#define lf long double
#define all(vec) vec.begin(), vec.end()
#define rall(vec) vec.rbegin(), vec.rend()
#define nl "\n"
#define chmyax(a, b) a = max(a, b)
#define chmyin(a, b) a = min(a, b)

bool check(pair<ll, ll> pos, ll n, ll m) {
  return pos.first >= 0 && pos.second >= 0 && pos.first < n && pos.second < m;
}

int main() {
  ios_base::sync_with_stdio(0);
  cin.tie(0);
  cout.tie(0);
  ll a, b, c, d, e, f, g, n, m;
  char ch;
  queue<pair<ll, ll>> bfs;
  set<pair<ll, ll>> visited;
  cin >> n >> m;
  vector<vector<bool>> arr(n, vector<bool>(m));
  for (ll i = 0; i < n; i++) {
    for (ll j = 0; j < m; j++) {
      cin >> ch;
      arr[i][j] = ch == '*';
    }
  }
  ll cnt = 0;
  for (ll i = 0; i < n; i++) {
    for (ll j = 0; j < m; j++) {
      if (!arr[i][j] || visited.count({i, j}))
        continue;
      visited.insert({i, j});
      cnt++;
      bfs.push({i, j});
      while (!bfs.empty()) {
        pair<ll, ll> curr = bfs.front();
        bfs.pop();
        for (pair<ll, ll> pos :
             vector<pair<ll, ll>>{{curr.first + 1, curr.second},
                                  {curr.first, curr.second + 1}}) {
          if (!check(pos, n, m) || !arr[pos.first][pos.second] ||
              visited.count(pos))
            continue;
          bfs.push(pos);
          visited.insert(pos);
        }
      }
    }
  }
  cout << cnt;
}
