#pragma GCC optimize("O3")

#include <bits/stdc++.h>

using namespace std;

#define ll long long
#define lf long double
#define all(vec) vec.begin(), vec.end()
#define rall(vec) vec.rbegin(), vec.rend()
#define nl "\n"
#define chmyax(a, b) a = max(a, b)
#define chmyin(a, b) a = min(a, b)

struct idk {
  ll i, j;
  bool ish;
};

bool operator<(const idk &first, const idk &second) {
  if (first.i != second.i)
    return first.i < second.i;
  if (first.j != second.j)
    return first.j < second.j;
  return first.ish < second.ish;
}

int main() {
  ios_base::sync_with_stdio(0);
  cin.tie(0);
  cout.tie(0);
  ll a, b, c, d, e, f, g, n, m, k;
  char ch;
  cin >> n >> m;
  vector<vector<bool>> arr(n + 2, vector<bool>(m + 2, 0));
  for (ll i = 1; i <= n; i++) {
    for (ll j = 1; j <= m; j++) {
      cin >> ch;
      arr[i][j] = ch == '#';
    }
  }
  vector<vector<pair<ll, ll>>> dp(
      n + 2, vector<pair<ll, ll>>(m + 2, {0, 0})); // first is vertical
  priority_queue<pair<ll, idk>> pq;
  for (ll i = 1; i <= n; i++) {
    for (ll j = 1; j <= m; j++) {
      if (!arr[i][j])
        continue;
      dp[i][j].first = dp[i - 1][j].first + 1;
      if (!arr[i + 1][j]) {
        pq.push({dp[i][j].first, {i, j, false}});
      }
      dp[i][j].second = dp[i][j - 1].second + 1;
      if (!arr[i][j + 1]) {
        pq.push({dp[i][j].second, {i, j, true}});
      }
    }
  }
  ll cnt = 0;
  while (!pq.empty()) {
    auto [dist, curr] = pq.top();
    pq.pop();
    if (curr.ish) {
      ll cr = 0;
      for (ll k = curr.j - dist + 1; k <= curr.j; k++) {
        if (!arr[curr.i][k]) {
          if (cr != 0) {
            pq.push({cr, {curr.i, k, true}});
          }
          cr = 0;
        } else {
          cr++;
        }
      }
      if (cr == dist) {
        for (ll k = curr.j - dist + 1; k <= curr.j; k++) {
          arr[curr.i][k] = 0;
        }
        cnt++;
      }
    } else {
      ll cr = 0;
      for (ll k = curr.i - dist + 1; k <= curr.i; k++) {
        if (!arr[k][curr.j]) {
          if (cr != 0) {
            pq.push({cr, {k, curr.j, false}});
          }
          cr = 0;
        } else {
          cr++;
        }
      }
      if (cr == dist) {
        for (ll k = curr.i - dist + 1; k <= curr.i; k++) {
          arr[k][curr.j] = 0;
        }
        cnt++;
      }
    }
  }
  cout << cnt;
}
