#pragma GCC optimize("O3")

#include <bits/stdc++.h>

using namespace std;

#define ll long long
#define lf long double
#define all(vec) vec.begin(), vec.end()
#define rall(vec) vec.rbegin(), vec.rend()
#define nl "\n"
#define chmyax(a, b) a = max(a, b)
#define chmyin(a, b) a = min(a, b)

#pragma GCC target("avx2")

int main() {
  ios_base::sync_with_stdio(0);
  cin.tie(0);
  cout.tie(0);
  // freopen("in", "r", stdin);
  ll a, b, c, d, e, f, g, n, m, k;
  char ch;
  cin >> n >> m;
  vector<ll> arr(n + 2, 0);
  for (ll i = 1; i <= n; i++) {
    for (ll j = 0; j < m; j++) {
      cin >> ch;
      arr[i] |= (ch == '#') << j;
    }
  }
  ll variations = (1 << m);
  vector<vector<ll>> dp(n + 1, vector<ll>(variations, 0));
  for (ll j = 1; j < variations; j++) {
    dp[0][j] = 1e9;
  }
  for (ll i = 1; i <= n; i++) {
    for (ll j = 0; j < variations; j++) {
      if ((~arr[i]) & j) {
        dp[i][j] = 1e9;
        continue;
      }
      ll invj = (~j) & arr[i];
      dp[i][j] =
          __builtin_popcount(arr[i]) - __builtin_popcount(invj & (invj << 1));
      ll mn = LLONG_MAX;
      for (ll k = 0; k < variations; k++) {
        ll score = dp[i - 1][k] - __builtin_popcount(k & j);
        chmyin(mn, score);
      }
      dp[i][j] += mn;
    }
  }
  ll mn = LLONG_MAX;
  for (ll j = 0; j < variations; j++) {
    chmyin(mn, dp[n][j]);
  }
  cout << mn;
}
