#include <iostream>
#include <vector>

using namespace std;
using ll = long long;

pair<ll, ll> aba = { -1, -1 }, aba1 = { -1, -1 };
vector<vector<ll>> used;
vector<vector<ll>> used1;
vector<vector<ll>> a;
vector<ll> path;
ll N, K, ans = -1;

void dfs(ll prev, ll ind, ll depth) {
	if (depth == K) {
		ans = ind;
		return;
	}
	if (aba.first != -1 || ans != -1) {
		return;
	}
	if (used[ind][prev] != -1) {
		aba.first = ind;
		aba.second = prev;
		return;
	}
	used[ind][prev] = depth;
	dfs(ind, a[ind][prev], depth + 1);
}
void dfspathsearch(ll prev, ll ind, ll depth) {
	if (aba1.first != -1) {
		return;
	}
	if (used1[ind][prev] != -1) {
		aba1.first = ind;
		aba1.second = prev;
		return;
	}
	path.push_back(ind);
	used1[ind][prev] = depth;
	dfspathsearch(ind, a[ind][prev], depth + 1);
}

int main() {
	cin >> N >> K;
	used.resize(N, vector<ll>(N, -1));
	used1.resize(N, vector<ll>(N, -1));
	a.resize(N, vector<ll>(N));
	for (ll i = 0; i < N; i++) {
		for (ll j = 0; j < N; j++) {
			cin >> a[i][j];
			a[i][j]--;
		}
	}
	if (K == 1) {
		cout << 1 << '\n';
		return 0;
	}
	dfs(0, 1, 2);
	if (ans != -1) {
		cout << ans + 1 << '\n';
		return 0;
	}
	dfspathsearch(aba.second, aba.first, used[aba.first][aba.second]);
	K -= used[aba.first][aba.second];
	K %= path.size();
	cout << path[K] + 1 << '\n';
}