#include <iostream>
#include <vector>

using namespace std;
using ll = long long;

int main() {
	ll N, M, ans = 0;
	bool changes = true;
	cin >> N >> M;
	vector<vector<char>> a(N + 2, vector<char>(M + 2, '.'));
	vector<vector<pair<ll, ll>>> a1(N + 2, vector<pair<ll, ll>>(M + 2, {0, 0}));
	for (ll i = 1; i <= N; i++) {
		for (ll j = 1; j <= M; j++) {
			cin >> a[i][j];
		}
	}
	for (ll i = 1; i <= N; i++) {
		for (ll j = 1; j <= M; j++) {
			if (a[i][j] == '#') {
				if (a[i][j - 1] == '.' && a[i][j + 1] == '.') {
					a[i][j] = '|';
				}
				else if (a[i - 1][j] == '.' && a[i + 1][j] == '.') {
					a[i][j] = '-';
				}
			}
		}
	}
	for (ll i = 1; i <= N; i++) {
		for (ll j = 1; j <= M; j++) {
			if (a[i][j] != '.') {
				if (a[i - 1][j] != '.' && a[i - 1][j] != '-') {
					a1[i][j].first = a1[i - 1][j].first;
				}
				else {
					for (ll k = i + 1; k <= N; k++) {
						if (a[k][j] != '.' && a[k][j] != '-') {
							a1[i][j].first++;
						}
						else {
							break;
						}
					}
				}
				if (a[i][j - 1] != '.' && a[i][j - 1] != '|') {
					a1[i][j].first = a1[i][j - 1].first;
				}
				else {
					for (ll k = j + 1; k <= M; k++) {
						if (a[i][k] != '.' && a[i][k] != '|') {
							a1[i][j].first++;
						}
						else {
							break;
						}
					}
				}
			}
		}
	}
	ll k;
	for (ll i = 1; i <= N; i++) {
		for (ll j = 1; j <= M; j++) {
			if (a[i][j] == '#') {
				if (a1[i][j].first > a1[i][j].second) {
					a[i][j] = '|';
					for (k = j; a[i][k] != '.' && a[i][k] != '|'; k--) {}
					for (k; k < j; k++) {
						if (a[i][k - 1] != '.' && a[i][k - 1] != '|') {
							a1[i][k].first = a1[i][k - 1].first;
						}
						else {
							for (ll k1 = k + 1; k1 <= M; k1++) {
								if (a[i][k1] != '.' && a[i][k1] != '|') {
									a1[i][k].first++;
								}
								else {
									break;
								}
							}
						}
					}
					for (k = j + 1; k <= M; k++) {
						if (a[i][k - 1] != '.' && a[i][k - 1] != '|') {
							a1[i][k].first = a1[i][k - 1].first;
						}
						else {
							for (ll k1 = k + 1; k1 <= M; k1++) {
								if (a[i][k1] != '.' && a[i][k1] != '|') {
									a1[i][k].first++;
								}
								else {
									break;
								}
							}
						}
					}
				}
				else {
					a[i][j] = '-';
					for (k = i; a[k][j] != '.' && a[k][j] != '-'; k--) {}
					for (k; k < i; k++) {
						if (a[k - 1][j] != '.' && a[k - 1][j] != '-') {
							a1[k][j].first = a1[k - 1][j].first;
						}
						else {
							for (ll k1 = k + 1; k1 <= N; k1++) {
								if (a[k1][j] != '.' && a[k1][j] != '-') {
									a1[k][j].first++;
								}
								else {
									break;
								}
							}
						}
					}
					for (k = i + 1; k <= N; k++) {
						if (a[k - 1][j] != '.' && a[k - 1][j] != '-') {
							a1[k][j].first = a1[k - 1][j].first;
						}
						else {
							for (ll k1 = k + 1; k1 <= N; k1++) {
								if (a[k1][j] != '.' && a[k1][j] != '-') {
									a1[k][j].first++;
								}
								else {
									break;
								}
							}
						}
					}
				}
			}
		}
	}
	while (changes) {
		changes = false;
		for (ll i = 1; i <= N; i++) {
			for (ll j = 1; j <= M; j++) {
				if (a[i][j] == '-') {
					if ((a[i][j + 1] != '-' || a[i][j - 1] != '-') && (a[i - 1][j] == '|' && a[i + 1][j] == '|')) {
						a[i][j] = '|';
						changes = true;
					}
				}
			}
		}
	}
	changes = true;
	while (changes) {
		changes = false;
		for (ll i = 1; i <= N; i++) {
			for (ll j = 1; j <= M; j++) {
				if (a[i][j] == '|') {
					if (a[i][j + 1] == '-' && a[i][j - 1] == '-' && (a[i + 1][j] != '|' || a[i - 1][j] != '|')) {
						a[i][j] = '-';
						changes = true;
					}
				}
			}
		}
	}
	for (ll i = 0; i <= N; i++) {
		for (ll j = 0; j <= M; j++) {
			if (a[i][j] != '-') {
				if (a[i][j + 1] == '-') {
					ans++;
				}
			}
			if (a[i][j] != '|') {
				if (a[i + 1][j] == '|') {
					ans++;
				}
			}
		}
	}
	cout << ans << '\n';
}