#include <iostream>
#include <vector>

using namespace std;
using ll = long long;

vector<vector<char>> a;
ll n, m, ans = 0;

void rec(ll idx, ll idy) {
	if (idx == n + 1) {
		idx = 1;
		idy++;
		if(idy == m + 1){
			ll ans1 = 0;
			for (ll i = 0; i <= n; i++) {
				for (ll j = 0; j <= m; j++) {
					if (a[i][j] != '-') {
						if (a[i][j + 1] == '-') {
							ans1++;
						}
					}
					if (a[i][j] != '|') {
						if (a[i + 1][j] == '|') {
							ans1++;
						}
					}
				}
			}
			ans = min(ans, ans1);
			return;
		}
	}
	if (a[idx][idy] == '#') {
		a[idx][idy] = '-';
		rec(idx + 1, idy);
		a[idx][idy] = '|';
		rec(idx + 1, idy);
		a[idx][idy] = '#';
	}
	else {
		rec(idx + 1, idy);
	}
}

int main() {
	cin >> n >> m;
	a.resize(n + 2, vector<char>(m + 2, '.'));
	for (ll i = 1; i <= n; i++) {
		for (ll j = 1; j <= m; j++) {
			cin >> a[i][j];
		}
	}
	if (n <= 10) {
		ans = 1000000000;
		rec(1, 1);
		cout << ans << '\n';
		return 0;
	}
	for (ll i = 1; i <= n; i++) {
		for (ll j = 1; j <= m; j++) {
			if (a[i][j] == '#') {
				if (a[i][j - 1] != '#' && a[i - 1][j] != '#') {
					ans++;
					if (a[i][j + 1] == '#' && a[i + 1][j] == '#') {
						ans++;
					}
				}
				else if (a[i][j - 1] != '#') {
					if (a[i][j + 1] == '#') {
						ans++;
					}
				}
				else if (a[i - 1][j] != '#') {
					if (a[i + 1][j] == '#') {
						ans++;
					}
				}
			}
		}
	}
	cout << ans << '\n';
 }