#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <algorithm>

using namespace std;
using ll = long long;
using ld = long double;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int n, q;
    cin >> n >> q;

    vector<ll> array(n);

    for (auto& element : array) {
        cin >> element;
    }

    auto get_max_cost = [&]() {
        // vector<int> prev_less(n, -1);
        // vector<int> prev_greater(n, -1);

        // for (int i = 0; i < n; i++) {
        //     for (int j = i - 1; j >= 0; j--) {
        //         if (array[j] > array[i]) {
        //             prev_greater[i] = j;
        //             break;
        //         }
        //     }

        //     for (int j = i - 1; j >= 0; j--) {
        //         if (array[j] < array[i]) {
        //             prev_less[i] = j;
        //             break;
        //         }
        //     }
        // }

        // vector<int> dp(n);
        // vector<int> left_edge(n);
        // vector<bool> is_last_max(n);
        
        // for (int i = 0; i < n; i++) {
        //     if (prev_less[i] == -1 || prev_greater[i] == -1) {
        //         dp[i] = 0;
        //         left_edge[i] = i;
        //         is_last_max[i] = true;
        //     } else if (prev_less[i] > prev_greater[i]) {
        //         dp[i] = array[i] - array[prev_less[i]];
        //         left_edge[i] = prev_less[i];
        //         is_last_max[i] = true;

        //         if (prev_less[i] == 0) {
        //         } else {
        //             if (!is_last_max[prev_less[i] - 1] && array[prev_less[i] - 1] >= array[prev_less[i]]) {
        //                 dp[i] = array[i] 
        //             }
        //         }
        //     } else {
        //         dp[i] = array[prev_greater[i]] - array[i];
        //         left_edge[i] = prev_greater[i];
        //         is_last_max[i] = false;

        //         if (prev_greater[i] == 0) {
        //         } else {

        //         }
        //     }
        // }

        vector<int> monotone_until(n);
        monotone_until[0] = 0;

        for (int i = 0; i < n - 1;) {
            int old_i = i;

            if (array[i] >= array[i + 1]) {
                while (i < n - 1 && array[i] >= array[i + 1]) {
                    i++;
                    monotone_until[i] = old_i;
                }
            } else if (array[i] < array[i + 1]) {
                while (i < n - 1 && array[i] < array[i + 1]) {
                    i++;
                    monotone_until[i] = old_i;
                }
            }
        }

        vector<ll> dp(n);
        dp[0] = 0;

        for (int i = 1; i < n; i++) {
            dp[i] = max(
                abs(array[i] - array[monotone_until[i]]) + (monotone_until[i] > 0 ? dp[monotone_until[i] - 1] : 0),
                abs(array[i] - array[monotone_until[i] + 1]) + dp[monotone_until[i]]
            );
        }

        return dp[n - 1];
    };

    for (int i = 0; i < q; i++) {
        int l, r;
        ll x;

        cin >> l >> r >> x;

        for (int j = l - 1; j < r; j++) {
            array[j] += x;
        }

        cout << get_max_cost() << "\n";
    }

    return 0;
}
