#include <bits/stdc++.h>
using namespace std;

const int DIM = 500;

set<int> edges[DIM];
vector<pair<int,int>> moment[DIM];
int q_pol, matrix[DIM][DIM];
long long q_ep;

void input_matrix(){
    for (int i = 0; i < q_pol; ++i)
        for (int j = 0; j < q_pol; ++j){
            cin >> matrix[i][j]; matrix[i][j]--;
        }
}

long long ind_pol(long long ep){
    int last = 0, curr = 1, next;
    long long curr_ep = 2;

    while (curr_ep < ep){
        next = matrix[curr][last];
        last = curr;
        curr = next;
        ++curr_ep;
    }

    return curr;
}

void find_cycle(long long &t_start, long long &t_end){
    long long time = 2;
    int last = 0, curr = 1, next;
    edges[1].insert(0);
    moment[1].push_back({0, 2});

    while (true){
        ++time;
        next = matrix[curr][last];
        last = curr;
        curr = next;

        if (edges[curr].find(last) != edges[curr].end()){
            for (int i = 0; i < moment[curr].size(); ++i)
                if (moment[curr][i].first == last){
                    t_start = moment[curr][i].second;
                    t_end = time;
                    return;
                }
        }
        else {
            edges[curr].insert(last);
            moment[curr].push_back({last, time});
        }
    }
}

int main() {
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);

    cin >> q_pol >> q_ep; input_matrix();
    if (q_ep == 1){
        cout << "1\n";
        return 0;
    }
    if (q_ep == 2){
        cout << "2\n";
        return 0;
    }

    long long t_start, t_end;
    find_cycle(t_start, t_end);

    cout << ind_pol(t_start + (q_ep - t_start) % (t_end - t_start)) + 1 << '\n';

    return 0;
}
