#include <stdio.h>
int main() {
    int n, k;
    scanf("%d %d", &n, &k);
    int blameList[n][n];
    for (int y = 0; y<n; y++) {
        for (int x = 0; x<n; x++) {
            scanf("%d", &blameList[y][x]);
        }
    }
    int crtGuest = 1;
    int blamedLastBy = 0;
    if (k <= 2) {
        printf("%d", k);
        return 0;
    }
    // first attempt: boring, ugly loop
    // optimization opportunity: see if the politicians repeat after some time (they should, right?) and use that to skip part of the loop
    int repeatA = -1;
    int repeatB = -1;
    int repeatI = 0;
    for (int i = 1; i<k-1; i++) {
        // get who to blame
        int toBlameNext = blameList[crtGuest][blamedLastBy] - 1;
        //printf("%d: %d will blame %d ([%d][%d])\n", i, crtGuest+1, toBlameNext+1, crtGuest, blamedLastBy);
        if (repeatA == -1) {
            repeatA = crtGuest;
            repeatB = toBlameNext;
            repeatI = i;
        } else if (repeatA == crtGuest && repeatB == toBlameNext) {
            // todo: 1 iteration seems to be missing
            // 67: 2 will blame 1
            int canSkip = (k-i)/(i-repeatI)+1;
            int skipping = canSkip*(i-repeatI);
            
            //printf("met again (current i: %d)! took this many loops: %d, skipping iters: %d (%d)\n", i, i-repeatI, skipping, canSkip);
            if (skipping-1 > 0) {
                i+=skipping-1;
                repeatA = -1;
                repeatB = -1;
                continue;
            }
        }
        blamedLastBy = crtGuest;
        crtGuest = toBlameNext;
        
    }
    printf("%d", crtGuest + 1);
}
