#include<iostream>
#include<vector>
#include<ios>
using namespace std;
typedef long long ll;

int n, m, ans;

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	cin >> n >> m;
	vector<vector<char>> v(n, vector<char>(m));
	vector<vector<bool>> a(n, vector<bool>(m, false));
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			cin >> v[i][j];
		}
	}

	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			if (v[i][j] == '#' && !a[i][j]) {
				if (i + 1 < n && j + 1 < m && v[i + 1][j] == '#' && v[i][j + 1] == '#') {
					int cnt1 = 0, cnt2 = 0;
					for (int k = j; k < m; k++) {
						if (a[i][k]) break;
						if (v[i][k] == '#') cnt1++;
					}

					for (int k = i; k < n; k++) {
						if (a[k][j]) break;
						if (v[k][j] == '#') cnt2++;
					}

					if (cnt1 >= cnt2) {
						for (int k = j; k < m; k++) {
							a[i][k] = true;
						}
					}
					else {
						for (int k = i; k < n; k++) {
							a[k][j] = true;
						}
					}
					ans++;
				}

				if (i + 1 < n && j - 1 >= 0 && v[i + 1][j] == '#' && v[i][j - 1] == '#') {
					int cnt1 = 0, cnt2 = 0;
					for (int k = j; k >= 0; k--) {
						if (a[i][k]) break;
						if (v[i][k] == '#') cnt1++;
					}

					for (int k = i; k < n; k++) {
						if (a[k][j]) break;
						if (v[k][j] == '#') cnt2++;
					}

					if (cnt1 >= cnt2) {
						for (int k = j; k >= 0; k--) {
							a[i][k] = true;
						}
					}
					else {
						for (int k = i; k < n; k++) {
							a[k][j] = true;
						}
					}
					ans++;
				}

				if (i - 1 >= 0 && j + 1 < m && v[i - 1][j] == '#' && v[i][j + 1] == '#') {
					int cnt1 = 0, cnt2 = 0;
					for (int k = j; k < m; k++) {
						if (a[i][k]) break;
						if (v[i][k] == '#') cnt1++;
					}

					for (int k = i; k >= 0; k--) {
						if (a[k][j]) break;
						if (v[k][j] == '#') cnt2++;
					}

					if (cnt1 >= cnt2) {
						for (int k = j; k < m; k++) {
							a[i][k] = true;
						}
					}
					else {
						for (int k = i; k >= 0; k--) {
							a[k][j] = true;
						}
					}
					ans++;
				}

				if (i - 1 >= 0 && j - 1 >= 0 && v[i - 1][j] == '#' && v[i][j - 1] == '#') {
					int cnt1 = 0, cnt2 = 0;
					for (int k = j; k >= 0; k--) {
						if (a[i][k]) break;
						if (v[i][k] == '#') cnt1++;
					}

					for (int k = i; k >= 0; k--) {
						if (a[k][j]) break;
						if (v[k][j] == '#') cnt2++;
					}

					if (cnt1 >= cnt2) {
						for (int k = j; k >= 0; k--) {
							a[i][k] = true;
						}
					}
					else {
						for (int k = i; k >= 0; k--) {
							a[k][j] = true;
						}
					}
					ans++;
				}
			}
		}
	}

	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			if (v[i][j] == '#' && !a[i][j]) ans++;
		}
	}

	cout << ans;
}