#include <bits/stdc++.h>
using namespace std;
using ll= long long;
const ll nmax=2e5+5;
const ll inf=2e9;

ll a[nmax];
ll ma[nmax*4], mi[nmax*4], push[nmax*4];

void build(ll v, ll tl, ll tr){
    if(tl==tr){
        ma[v]=a[tl];
        mi[v]=a[tl];
    }
    else{
        ll mid=(tl+tr)/2;
        build(v*2, tl, mid);
        build(v*2+1, mid+1, tr);
        ma[v]=max(ma[v*2], ma[v*2+1]);
        mi[v]=min(mi[v*2], mi[v*2+1]);
    }
}

void dopush(ll v){
    if(push[v]==0) return;

    push[v*2]+=push[v];
    push[v*2+1]+=push[v];

    ma[v*2]+=push[v];
    ma[v*2+1]+=push[v];

    mi[v*2]+=push[v];
    mi[v*2+1]+=push[v];

    push[v]=0;

}

void change(ll v, ll tl, ll tr, ll l, ll r, ll val){
    if(tl > r || l > tr) return;
    if(l <= tl && tr <= r){
        push[v]+=val;
        ma[v]+=val;
        mi[v]+=val;
    }
    else{
        ll mid=(tl+tr)/2;
        //dopush(v);
        change(v*2, tl, mid, l, r, val);
        change(v*2+1, mid+1, tr, l , r, val);

        ma[v]=max(ma[v*2], ma[v*2+1]);
        mi[v]=min(mi[v*2], mi[v*2+1]);
    }
}

ll getma(ll v, ll tl, ll tr, ll l, ll r){
    if(tl > r || l > tr) return -inf;
    if(l <= tl && tr <= r) return ma[v];
    ll mid=(tl+tr)/2;
    //dopush(v);
        
    return max(getma(v*2, tl, mid, l, r), getma(v*2+1, mid+1, tr, l, r));
}

ll getmi(ll v, ll tl, ll tr, ll l, ll r){
    if(tl > r || l > tr) return inf;
    if(l <= tl && tr <= r) return mi[v];
    ll mid=(tl+tr)/2;
    //dopush(v);
        
    return min(getmi(v*2, tl, mid, l, r), getmi(v*2+1, mid+1, tr, l , r));
}


int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    ll n, q;
    cin >> n >> q;

    for (int i = 1; i <= n; i++) cin >> a[i];

    //build(1, 1, n);

    ll dp[n+3];

    ll l, r, val;
    while(q--){
        cin >> l >> r >> val;

        for (int i = l; i <= r; i++) a[i]+=val;
        build(1, 1, n);
        
        //change(1, 1, n, l, r, val);


        fill(dp, dp+n+1, 0);

        for (int i = 2; i <= n; i++){
            for (int last = 1; last < i; last++){
                dp[i]=max(dp[last-1]+getma(1, 1, n, last, i)-getmi(1, 1, n, last, i), dp[i]);
                //dp[i]=max(dp[i], dp[i-1]);
                //cout << last <<  ' ' << i << "  " << dp[last-1] << ' ' << getma(1, 1, n, last, i) << ' ' << getmi(1, 1, n, last, i) << "\n";
            }
        }

        //cout << getma(1, 1, n, 1, 4) << '\n';

        //cout << '\n';
        //for (int i = 1; i <= n; i++) cout << dp[i] << ' ';
        cout << dp[n] << '\n';
        
    }


}
